Only in mine/: biossums
Only in mine/: biossums.c
diff -ur bios/Makefile mine/Makefile
--- bios/Makefile	2007-09-25 14:27:12.000000000 -0600
+++ mine/Makefile	2007-09-25 14:36:49.000000000 -0600
@@ -29,9 +29,16 @@
 .cc.o:
 	$(CXX) -c $(CXXFLAGS) $(LOCAL_CXXFLAGS) $(BX_INCDIRS) $< -o $@
 
-bios: rombios.bin
+bios: rombios.bin BIOS-bochs-latest biossums
 
-rombios.bin: rombios.c
+date.c:
+	echo "#ifndef BIOS_BUILD_DATE"> date.c
+	echo "#define BIOS_BUILD_DATE  \""`date +%D`"\"" >> date.c
+	echo -e "#endif\n" >> date.c
+	echo "static char bios_cvs_version_string[] = \"`date +%T`\";">> date.c
+	echo >> date.c
+
+rombios.bin: rombios.c date.c 
 	gcc -E -P $< > _rombios_.c
 	bcc -o rombios.s -C-c -D__i86__ -0 -S _rombios_.c
 	sed -e 's/^\.text//' -e 's/^\.data//' rombios.s > _rombios_.s
@@ -41,10 +48,20 @@
 # -----------------------------------------------------------------
 
 clean:
+	rm -f  date.c
 	rm -f  *.s
 	rm -f  _rombios_.c
 	rm -f  rombios.txt
 	rm -f  rombios.bin
+	rm -f  rombios.sym
+	rm BIOS-bochs-latest
+
+BIOS-bochs-latest: rombios.bin biossums
+	-perl ./makesym.perl < rombios.txt > rombios.sym
+	cp rombios.bin BIOS-bochs-latest
+	./biossums BIOS-bochs-latest
 
 
+biossums: biossums.c
+	gcc -o biossums biossums.c
 # -----------------------------------------------------------------
Only in mine/: makesym.perl
diff -ur bios/rombios.c mine/rombios.c
--- bios/rombios.c	2007-09-25 14:27:12.000000000 -0600
+++ mine/rombios.c	2007-09-25 14:34:42.000000000 -0600
@@ -124,8 +124,8 @@
 
 #define DEBUG_ROMBIOS      1
 
-#define DEBUG_ATA          0
-#define DEBUG_INT13_HD     0
+#define DEBUG_ATA          1
+#define DEBUG_INT13_HD     1
 #define DEBUG_INT13_CD     0
 #define DEBUG_INT13_ET     0
 #define DEBUG_INT13_FL     0
@@ -139,7 +139,7 @@
 #define BX_USE_PS2_MOUSE 1
 #define BX_CALL_INT15_4F 1
 #define BX_USE_EBDA      1
-#define BX_SUPPORT_FLOPPY 1
+#define BX_SUPPORT_FLOPPY 0
 #define BX_FLOPPY_ON_CNT 37   /* 2 seconds */
 //#define BX_PCIBIOS       1
 #define BX_APM           0
@@ -147,9 +147,9 @@
 #define LINUXBIOS	1
 
 #define BX_USE_ATADRV    1
-//#define BX_ELTORITO_BOOT 1
+#define BX_ELTORITO_BOOT 1
 
-#define BX_MAX_ATA_INTERFACES   4
+#define BX_MAX_ATA_INTERFACES   2
 #define BX_MAX_ATA_DEVICES      (BX_MAX_ATA_INTERFACES*2)
 
 #define BX_VIRTUAL_PORTS 1 /* normal output to Bochs ports */
@@ -161,10 +161,6 @@
 #define BIOS_REVISION    1
 #define BIOS_CONFIG_TABLE 0xe6f5
 
-#ifndef BIOS_BUILD_DATE
-#  define BIOS_BUILD_DATE "06/23/99"
-#endif
-
   // 1K of base memory used for Extended Bios Data Area (EBDA)
   // EBDA is used for PS/2 mouse support, and IDE BIOS, etc.
 #define EBDA_SEG           0x9FC0
@@ -656,8 +652,7 @@
  
   typedef struct {
     Bit8u  iface;        // ISA or PCI
-    Bit16u iobase1;      // IO Base 1
-    Bit16u iobase2;      // IO Base 2
+    Bit16u iobase;      // IO Base 1
     Bit8u  irq;          // IRQ
     } ata_channel_t;
 
@@ -666,8 +661,7 @@
     Bit8u  device;       // Detected type of attached devices (hd/cd/none)
     Bit8u  removable;    // Removable device flag
     Bit8u  lock;         // Locks for removable devices
-    // Bit8u  lba_capable;  // LBA capable flag - always yes for bochs devices
-    Bit8u  mode;         // transfert mode : PIO 16/32 bits - IRQ - ISADMA - PCIDMA
+    Bit8u  mode;         // transfer mode : PIO 16/32 bits - IRQ - ISADMA - PCIDMA
     Bit16u blksize;      // block size
 
     Bit8u  translation;  // type of translation
@@ -780,7 +774,6 @@
     } dpt_t;
  
   #define Int13DPT ((dpt_t *) 0)
-
 #endif // BX_USE_ATADRV
 
 typedef struct {
@@ -909,9 +902,13 @@
 # if BX_USE_ATADRV
 
 // ATA / ATAPI driver
+void   mdelay();
+#define udelay() (inb(0x80)||inb(0x80))
 void   ata_init();
 void   ata_detect();
 void   ata_reset();
+Bit16u   ata_device_selection();
+void   ata_device_reset();
 
 Bit16u ata_cmd_non_data();
 Bit16u ata_cmd_data_in();
@@ -930,12 +927,11 @@
 Bit8u  cdemu_isactive();
 Bit8u  cdemu_emulated_drive();
 
+#include "date.c"
 Bit16u cdrom_boot();
 
 #endif // BX_ELTORITO_BOOT
 
-static char bios_cvs_version_string[] = "$Revision: 1.163 $ $Date: 2006/07/07 16:10:37 $";
-
 #define BIOS_COPYRIGHT_STRING "(c) 2002 MandrakeSoft S.A. Written by Kevin Lawton & the Bochs team."
 
 #define BIOS_PRINTF_HALT     1
@@ -1592,9 +1588,20 @@
           }
         else if (c == 'l') {
           s++;
+  	  c = read_byte(get_CS(), s);
           arg_ptr++; /* increment to next arg */
           hibyte = read_word(arg_seg, arg_ptr);
-          put_luint(action, ((Bit32u) hibyte << 16) | arg, format_width, 0);
+          if (c == 'd')
+            put_luint(action, ((Bit32u) hibyte << 16) | arg, format_width, 0);
+          else
+           {
+          if (format_width == 0)
+            format_width = 8;
+          for (i=format_width-1; i>=0; i--) {
+            nibble = ((((Bit32u) hibyte <<16) | arg) >> (4 * i)) & 0x000f;
+            send (action, (nibble<=9)? (nibble+'0') : (nibble-10+'A'));
+            }
+           }
           }
         else if (c == 'd') {
           if (arg & 0x8000)
@@ -1616,7 +1623,7 @@
     else {
       send(action, c);
       }
-    s ++;
+    s++;
     }
 
   if (action & BIOS_PRINTF_HALT) {
@@ -1818,7 +1825,7 @@
 void
 print_bios_banner()
 {
-  printf(BX_APPNAME" BIOS - build: %s\n%s\nOptions: ",
+  printf(BX_APPNAME" BIOS - build: %s %s\nOptions: ",
     BIOS_BUILD_DATE, bios_cvs_version_string);
   printf(
 #ifdef BX_PCIBIOS
@@ -1968,9 +1975,10 @@
 #define ATA_CB_DH    6   // device head      in/out pio_base_addr1+6
 #define ATA_CB_STAT  7   // primary status   in     pio_base_addr1+7
 #define ATA_CB_CMD   7   // command             out pio_base_addr1+7
-#define ATA_CB_ASTAT 6   // alternate status in     pio_base_addr2+6
-#define ATA_CB_DC    6   // device control      out pio_base_addr2+6
-#define ATA_CB_DA    7   // device address   in     pio_base_addr2+7
+//only use one iobase
+#define ATA_CB_ASTAT 0x204+2   // alternate status in     pio_base_addr2+2
+#define ATA_CB_DC    0x204+2   // device control      out pio_base_addr2+2
+#define ATA_CB_DA    0x204+3   // device address   in     pio_base_addr2+3
 
 #define ATA_CB_ER_ICRC 0x80    // ATA Ultra DMA bad CRC
 #define ATA_CB_ER_BBK  0x80    // ATA bad block
@@ -1997,6 +2005,7 @@
 // bits 7-4 of the device/head (CB_DH) reg
 #define ATA_CB_DH_DEV0 0xa0    // select device 0
 #define ATA_CB_DH_DEV1 0xb0    // select device 1
+#define ATA_CB_DH_LBA 0x40    // use LBA
 
 // status reg (CB_STAT and CB_ASTAT) bits
 #define ATA_CB_STAT_BSY  0x80  // busy
@@ -2046,6 +2055,7 @@
 #define ATA_CMD_READ_SECTORS                 0x20
 #define ATA_CMD_READ_VERIFY_SECTORS          0x40
 #define ATA_CMD_RECALIBRATE                  0x10
+#define ATA_CMD_REQUEST_SENSE                0x03
 #define ATA_CMD_SEEK                         0x70
 #define ATA_CMD_SET_FEATURES                 0xEF
 #define ATA_CMD_SET_MULTIPLE_MODE            0xC6
@@ -2102,8 +2112,7 @@
   // Channels info init. 
   for (channel=0; channel<BX_MAX_ATA_INTERFACES; channel++) {
     write_byte(ebda_seg,&EbdaData->ata.channels[channel].iface,ATA_IFACE_NONE);
-    write_word(ebda_seg,&EbdaData->ata.channels[channel].iobase1,0x0);
-    write_word(ebda_seg,&EbdaData->ata.channels[channel].iobase2,0x0);
+    write_word(ebda_seg,&EbdaData->ata.channels[channel].iobase,0x0);
     write_byte(ebda_seg,&EbdaData->ata.channels[channel].irq,0);
     }
 
@@ -2136,6 +2145,71 @@
   write_byte(ebda_seg,&EbdaData->ata.cdcount,0);
 }
 
+#define TIMEOUT 0
+#define BSY 1
+#define NOT_BSY 2
+#define NOT_BSY_DRQ 3
+#define NOT_BSY_NOT_DRQ 4
+
+#define IDE_TIMEOUT 32000u
+
+void print_status();
+static void print_status(base)
+	   Bit16u base;
+{
+	printf("\tstatus=%2x, err=%2x, sc = %2x, cl = %2x ch = %2x dh=%2x\n",
+		inb(base+ATA_CB_STAT), inb(base+ATA_CB_ERR), inb(base+ATA_CB_SC),
+		inb(base+ATA_CB_CL), inb(base+ATA_CB_CH), inb(base+ATA_CB_DH));
+}
+
+int await_ide();
+static int await_ide(when_done,base,timeout)
+	   Bit8u when_done;
+	   Bit16u base;
+	   Bit16u timeout;
+{
+	Bit32u time=0,last=0;
+	Bit16u status;
+	Bit8u result;
+  	status = inb(base + ATA_CB_ASTAT); // for the times you're supposed to throw one away
+	for(;;) {
+	   status = inb(base+ATA_CB_STAT);
+	   time++;
+	   if (when_done == BSY)
+		result = status & ATA_CB_STAT_BSY;
+	   else if (when_done == NOT_BSY)
+		result = !(status & ATA_CB_STAT_BSY);
+	   else if (when_done == NOT_BSY_DRQ)
+		result = !(status & ATA_CB_STAT_BSY) && (status & ATA_CB_STAT_DRQ);
+	   else if (when_done == NOT_BSY_NOT_DRQ)
+		result = !(status & ATA_CB_STAT_BSY) && !(status & ATA_CB_STAT_DRQ);
+	   else if (when_done == TIMEOUT)
+	     result = 0;
+	   
+		if (result) {
+			return 0;
+		}
+		if (time>>16 != last) // mod 2048 each 16 ms
+		{
+			last = time >>16;
+		    BX_DEBUG_ATA("await_ide: (TIMEOUT,BSY,!BSY,!BSY_DRQ,!BSY_!DRQ) %d time= %ld timeout= %d\n",when_done,time>>11, timeout);
+			print_status(base);
+	         
+          	}
+		if (status & ATA_CB_STAT_ERR)
+		{
+			printf("await_ide: ERROR (TIMEOUT,BSY,!BSY,!BSY_DRQ,!BSY_!DRQ) %d time= %ld timeout= %d\n",when_done,time>>11, timeout);
+			print_status(base);
+			return -1;
+		}
+		if ((timeout == 0) || ((time>>11) > timeout)) {
+			break;
+		}
+	}
+	BX_INFO("IDE time out\n");
+	return -1;
+}
+
 // ---------------------------------------------------------------------------
 // ATA/ATAPI driver : device detection
 // ---------------------------------------------------------------------------
@@ -2149,76 +2223,69 @@
 
 #if BX_MAX_ATA_INTERFACES > 0
   write_byte(ebda_seg,&EbdaData->ata.channels[0].iface,ATA_IFACE_ISA);
-  write_word(ebda_seg,&EbdaData->ata.channels[0].iobase1,0x1f0);
-  write_word(ebda_seg,&EbdaData->ata.channels[0].iobase2,0x3f0);
+  write_word(ebda_seg,&EbdaData->ata.channels[0].iobase,0x1f0);
   write_byte(ebda_seg,&EbdaData->ata.channels[0].irq,14);
 #endif
 #if BX_MAX_ATA_INTERFACES > 1
   write_byte(ebda_seg,&EbdaData->ata.channels[1].iface,ATA_IFACE_ISA);
-  write_word(ebda_seg,&EbdaData->ata.channels[1].iobase1,0x170);
-  write_word(ebda_seg,&EbdaData->ata.channels[1].iobase2,0x370);
+  write_word(ebda_seg,&EbdaData->ata.channels[1].iobase,0x170);
   write_byte(ebda_seg,&EbdaData->ata.channels[1].irq,15);
 #endif
 #if BX_MAX_ATA_INTERFACES > 2
   write_byte(ebda_seg,&EbdaData->ata.channels[2].iface,ATA_IFACE_ISA);
-  write_word(ebda_seg,&EbdaData->ata.channels[2].iobase1,0x1e8);
-  write_word(ebda_seg,&EbdaData->ata.channels[2].iobase2,0x3e0);
+  write_word(ebda_seg,&EbdaData->ata.channels[2].iobase,0x1e8);
   write_byte(ebda_seg,&EbdaData->ata.channels[2].irq,12);
 #endif
 #if BX_MAX_ATA_INTERFACES > 3
-  write_byte(ebda_seg,&EbdaData->ata.channels[3].iface,ATA_IFACE_ISA);
-  write_word(ebda_seg,&EbdaData->ata.channels[3].iobase1,0x168);
-  write_word(ebda_seg,&EbdaData->ata.channels[3].iobase2,0x360);
-  write_byte(ebda_seg,&EbdaData->ata.channels[3].irq,11);
-#endif
-#if BX_MAX_ATA_INTERFACES > 4
 #error Please fill the ATA interface informations
 #endif
 
   // Device detection
   hdcount=cdcount=0;
-  
+
   for(device=0; device<BX_MAX_ATA_DEVICES; device++) {
-    Bit16u iobase1, iobase2;
-    Bit8u  channel, slave, shift;
+    Bit16u iobase;
+    Bit8u  channel, slave;
     Bit8u  sc, sn, cl, ch, st;
 
     channel = device / 2;
     slave = device % 2;
 
-    iobase1 =read_word(ebda_seg,&EbdaData->ata.channels[channel].iobase1);
-    iobase2 =read_word(ebda_seg,&EbdaData->ata.channels[channel].iobase2);
+    iobase =read_word(ebda_seg,&EbdaData->ata.channels[channel].iobase);
 
     // Disable interrupts
-    outb(iobase2+ATA_CB_DC, ATA_CB_DC_HD15 | ATA_CB_DC_NIEN);
+    outb(iobase+ATA_CB_DC, ATA_CB_DC_HD15 | ATA_CB_DC_NIEN);
 
     // Look for device
-    outb(iobase1+ATA_CB_DH, slave ? ATA_CB_DH_DEV1 : ATA_CB_DH_DEV0);
-    outb(iobase1+ATA_CB_SC, 0x55);
-    outb(iobase1+ATA_CB_SN, 0xaa);
-    outb(iobase1+ATA_CB_SC, 0xaa);
-    outb(iobase1+ATA_CB_SN, 0x55);
-    outb(iobase1+ATA_CB_SC, 0x55);
-    outb(iobase1+ATA_CB_SN, 0xaa);
+    outb(iobase+ATA_CB_DH, slave ? ATA_CB_DH_DEV1 : ATA_CB_DH_DEV0);
+	mdelay(50);
+    outb(iobase+ATA_CB_SC, 0x55);
+    outb(iobase+ATA_CB_SN, 0xaa);
+    outb(iobase+ATA_CB_SC, 0xaa);
+    outb(iobase+ATA_CB_SN, 0x55);
+    outb(iobase+ATA_CB_SC, 0x55);
+    outb(iobase+ATA_CB_SN, 0xaa);
 
     // If we found something
-    sc = inb(iobase1+ATA_CB_SC);
-    sn = inb(iobase1+ATA_CB_SN);
+    sc = inb(iobase+ATA_CB_SC);
+    sn = inb(iobase+ATA_CB_SN);
 
     if ( (sc == 0x55) && (sn == 0xaa) ) {
+      BX_DEBUG_ATA("found a device #%d\n",device);
       write_byte(ebda_seg,&EbdaData->ata.devices[device].type,ATA_TYPE_UNKNOWN);
     
       // reset the channel
       ata_reset(device);
       
       // check for ATA or ATAPI
-      outb(iobase1+ATA_CB_DH, slave ? ATA_CB_DH_DEV1 : ATA_CB_DH_DEV0);
-      sc = inb(iobase1+ATA_CB_SC);
-      sn = inb(iobase1+ATA_CB_SN);
+      outb(iobase+ATA_CB_DH, slave ? ATA_CB_DH_DEV1 : ATA_CB_DH_DEV0);
+      sc = inb(iobase+ATA_CB_SC);
+      sn = inb(iobase+ATA_CB_SN);
+      BX_DEBUG_ATA("device %d detect sc = %02x sn= %02x\n",device,sc,sn);
       if ((sc==0x01) && (sn==0x01)) {
-        cl = inb(iobase1+ATA_CB_CL);
-        ch = inb(iobase1+ATA_CB_CH);
-        st = inb(iobase1+ATA_CB_STAT);
+        cl = inb(iobase+ATA_CB_CL);
+        ch = inb(iobase+ATA_CB_CH);
+        st = inb(iobase+ATA_CB_STAT);
 
         if ((cl==0x14) && (ch==0xeb)) {
           write_byte(ebda_seg,&EbdaData->ata.devices[device].type,ATA_TYPE_ATAPI);
@@ -2229,10 +2296,20 @@
         }
       }
     }
+    // Enable Interrupts
+    outb(iobase+ATA_CB_DC, ATA_CB_DC_HD15);
+   }
+
+  for(device=0; device<BX_MAX_ATA_DEVICES; device++) {
+    Bit8u  channel, slave, shift;
+
+    channel = device / 2;
+    slave = device % 2;
 
     type=read_byte(ebda_seg,&EbdaData->ata.devices[device].type);
-    
-    // Now we send a IDENTIFY command to ATA device 
+    BX_DEBUG_ATA("device %d type = %1x\n",device,type);
+
+    // Now we send an IDENTIFY command to ATA device 
     if(type == ATA_TYPE_ATA) {
       Bit32u sectors;
       Bit16u cylinders, heads, spt, blksize;
@@ -2255,6 +2332,8 @@
 
       sectors   = read_dword(get_SS(),buffer+(60*2)); // word 60 and word 61
 
+    BX_DEBUG_ATA("device %d removable %d mode %d blksize %d cyl %d heads %d spt %d sectors %lx\n",device,removable,mode,blksize,cylinders,heads,spt,sectors);
+
       write_byte(ebda_seg,&EbdaData->ata.devices[device].device,ATA_DEVICE_HD);
       write_byte(ebda_seg,&EbdaData->ata.devices[device].removable, removable);
       write_byte(ebda_seg,&EbdaData->ata.devices[device].mode, mode);
@@ -2298,6 +2377,9 @@
           else if (heads>16) heads = 32;
           else heads=16;
           cylinders = sectors / heads;
+      		write_word(ebda_seg,&EbdaData->ata.devices[device].pchs.heads, heads);
+      		write_word(ebda_seg,&EbdaData->ata.devices[device].pchs.cylinders, cylinders);
+      		write_word(ebda_seg,&EbdaData->ata.devices[device].pchs.spt, spt);
           break;
         case ATA_TRANSLATION_RECHS:
           // Take care not to overflow
@@ -2348,6 +2430,8 @@
       mode      = read_byte(get_SS(),buffer+96) ? ATA_MODE_PIO32 : ATA_MODE_PIO16;
       blksize   = 2048;
 
+    BX_DEBUG_ATA("device %d removable %d mode %d blksize %d\n",device,removable,mode,blksize);
+
       write_byte(ebda_seg,&EbdaData->ata.devices[device].device, type);
       write_byte(ebda_seg,&EbdaData->ata.devices[device].removable, removable);
       write_byte(ebda_seg,&EbdaData->ata.devices[device].mode, mode);
@@ -2425,69 +2509,80 @@
   
 }
 
+//ATA-4 9.6 Device Selection protocol
+// Figure 11
+// BSY=0 and DRQ=0 before starting
+// Don't call after ata_reset for non-packet devices
+
+Bit16u   ata_device_selection(device,base,slave)
+Bit16u device,base,slave;
+{
+  Bit16u status;
+  return await_ide(NOT_BSY_NOT_DRQ, base, IDE_TIMEOUT);
+	// Write Device/Head Reg
+  outb(base + ATA_CB_DH, (slave ? ATA_CB_DH_DEV1 : ATA_CB_DH_DEV0));
+  udelay(); /* spec says wait 400 ns , 1 us is close enough */
+  return await_ide(NOT_BSY_NOT_DRQ, base, IDE_TIMEOUT);
+}
+
+//ATA-4 9.4 DEVICE RESET protocol 
+// The whole thing should take < 6 s
+
+void   ata_device_reset(device)
+Bit16u device;
+{
+  Bit16u status;
+  Bit16u base;
+  Bit16u ebda_seg=read_word(0x0040,0x000E);
+  Bit8u slave = device & 0x1;
+  base = read_word(ebda_seg, &EbdaData->ata.channels[device/2].iobase);
+
+  //9.4 (a)
+  outb(base + ATA_CB_DH, (slave ? ATA_CB_DH_DEV1 : ATA_CB_DH_DEV0));
+  outb(base + ATA_CB_CMD, ATA_CMD_DEVICE_RESET);
+  //9.4 (c)
+  udelay(); /* 9.4 (c) spec says wait 400 ns , 1 us is close enough */
+  await_ide(BSY, base, IDE_TIMEOUT); // This could be shorter
+  //9.4 (j)
+  await_ide(NOT_BSY, base, IDE_TIMEOUT);
+}
+
 // ---------------------------------------------------------------------------
 // ATA/ATAPI driver : software reset 
 // ---------------------------------------------------------------------------
-// ATA-3
-// 8.2.1 Software reset - Device 0
+// ATA-4
+// 9.3.1-2 Software reset - Device 0 or 1
 
 void   ata_reset(device)
 Bit16u device;
 {
   Bit16u ebda_seg=read_word(0x0040,0x000E);
-  Bit16u iobase1, iobase2;
-  Bit8u  channel, slave, sn, sc; 
-  Bit16u max;
+  Bit16u iobase;
+  Bit8u  channel, type;
 
   channel = device / 2;
-  slave = device % 2;
 
-  iobase1 = read_word(ebda_seg, &EbdaData->ata.channels[channel].iobase1);
-  iobase2 = read_word(ebda_seg, &EbdaData->ata.channels[channel].iobase2);
+  iobase = read_word(ebda_seg, &EbdaData->ata.channels[channel].iobase);
 
   // Reset
 
-// 8.2.1 (a) -- set SRST in DC
-  outb(iobase2+ATA_CB_DC, ATA_CB_DC_HD15 | ATA_CB_DC_NIEN | ATA_CB_DC_SRST);
-
-// 8.2.1 (b) -- wait for BSY
-  max=0xff;
-  while(--max>0) {
-    Bit8u status = inb(iobase1+ATA_CB_STAT);
-    if ((status & ATA_CB_STAT_BSY) != 0) break;
-  }
-
-// 8.2.1 (f) -- clear SRST
-  outb(iobase2+ATA_CB_DC, ATA_CB_DC_HD15 | ATA_CB_DC_NIEN);
-
-  if (read_byte(ebda_seg,&EbdaData->ata.devices[device].type) != ATA_TYPE_NONE) {
-
-// 8.2.1 (g) -- check for sc==sn==0x01
-    // select device
-    outb(iobase1+ATA_CB_DH, slave?ATA_CB_DH_DEV1:ATA_CB_DH_DEV0);
-    sc = inb(iobase1+ATA_CB_SC);
-    sn = inb(iobase1+ATA_CB_SN);
-
-    if ( (sc==0x01) && (sn==0x01) ) {
-
-// 8.2.1 (h) -- wait for not BSY
-      max=0xff;
-      while(--max>0) {
-        Bit8u status = inb(iobase1+ATA_CB_STAT);
-        if ((status & ATA_CB_STAT_BSY) == 0) break;
-        }
-      }
-    }
-
-// 8.2.1 (i) -- wait for DRDY
-  max=0xfff;
-  while(--max>0) {
-    Bit8u status = inb(iobase1+ATA_CB_STAT);
-      if ((status & ATA_CB_STAT_RDY) != 0) break;
-  }
-
-  // Enable interrupts
-  outb(iobase2+ATA_CB_DC, ATA_CB_DC_HD15);
+// 9.3.1 (a), 9.3.2 (a) -- set SRST in DC
+  outb(iobase+ATA_CB_DC, ATA_CB_DC_HD15 | ATA_CB_DC_NIEN | ATA_CB_DC_SRST);
+  udelay(); udelay(); udelay(); udelay(); udelay(); //5 us
+
+// 9.3.1 (c), 9.3.2 (c) -- wait for BSY
+  await_ide(BSY, iobase, IDE_TIMEOUT);
+
+// 9.3.1 (f), 9.3.2 (g) -- clear SRST
+  outb(iobase+ATA_CB_DC, ATA_CB_DC_HD15 | ATA_CB_DC_NIEN);
+
+// 9.3.1 (l), 9.3.2 (m) -- wait for !BSY
+  await_ide(NOT_BSY, iobase, IDE_TIMEOUT);
+
+// 9.3.1 (m), 9.3.2 (n) -- wait for !BSY and DRQ if not ATA_TYPE_PACKET
+  type = read_byte(ebda_seg,&EbdaData->ata.devices[device].type); 
+  if (type == ATA_TYPE_ATA)
+  	await_ide(NOT_BSY_DRQ, iobase, IDE_TIMEOUT);
 }
 
 // ---------------------------------------------------------------------------
@@ -2514,53 +2609,52 @@
 Bit32u lba;
 {
   Bit16u ebda_seg=read_word(0x0040,0x000E);
-  Bit16u iobase1, iobase2, blksize;
-  Bit8u  channel, slave;
+  Bit16u iobase, blksize;
+  Bit8u  channel, slave, translation;
   Bit8u  status, current, mode;
 
   channel = device / 2;
   slave   = device % 2;
 
-  iobase1 = read_word(ebda_seg, &EbdaData->ata.channels[channel].iobase1);
-  iobase2 = read_word(ebda_seg, &EbdaData->ata.channels[channel].iobase2);
+  iobase = read_word(ebda_seg, &EbdaData->ata.channels[channel].iobase);
   mode    = read_byte(ebda_seg, &EbdaData->ata.devices[device].mode);
+  translation = read_byte(ebda_seg,&EbdaData->ata.devices[device].translation);
   blksize = 0x200; // was = read_word(ebda_seg, &EbdaData->ata.devices[device].blksize);
   if (mode == ATA_MODE_PIO32) blksize>>=2;
   else blksize>>=1;
 
-  // sector will be 0 only on lba access. Convert to lba-chs
-  if (sector == 0) {
+  if(translation == ATA_TRANSLATION_LBA) //Convert to lba-chs
+  {
     sector = (Bit16u) (lba & 0x000000ffL);
-    lba >>= 8;
-    cylinder = (Bit16u) (lba & 0x0000ffffL);
-    lba >>= 16;
-    head = ((Bit16u) (lba & 0x0000000fL)) | 0x40;
-    }
+    cylinder = (Bit16u) ((lba>>8) & 0x0000ffffL);
+    head = ((Bit16u) ((lba>>24) & 0x0000000fL)) | ATA_CB_DH_LBA;
+  }
 
   // Reset count of transferred data
   write_word(ebda_seg, &EbdaData->ata.trsfsectors,0);
   write_dword(ebda_seg, &EbdaData->ata.trsfbytes,0L);
   current = 0;
 
-  status = inb(iobase1 + ATA_CB_STAT);
-  if (status & ATA_CB_STAT_BSY) return 1;
-
-  outb(iobase2 + ATA_CB_DC, ATA_CB_DC_HD15 | ATA_CB_DC_NIEN);
-  outb(iobase1 + ATA_CB_FR, 0x00);
-  outb(iobase1 + ATA_CB_SC, count);
-  outb(iobase1 + ATA_CB_SN, sector);
-  outb(iobase1 + ATA_CB_CL, cylinder & 0x00ff);
-  outb(iobase1 + ATA_CB_CH, cylinder >> 8);
-  outb(iobase1 + ATA_CB_DH, (slave ? ATA_CB_DH_DEV1 : ATA_CB_DH_DEV0) | (Bit8u) head );
-  outb(iobase1 + ATA_CB_CMD, command);
+  if (ata_device_selection(device,iobase,slave)!=0) return 1;
 
-  while (1) {
-    status = inb(iobase1 + ATA_CB_STAT);
-    if ( !(status & ATA_CB_STAT_BSY) ) break;
-    }
+  outb(iobase + ATA_CB_DC, ATA_CB_DC_HD15 | ATA_CB_DC_NIEN);
+  outb(iobase + ATA_CB_FR, 0x00);
+  outb(iobase + ATA_CB_SC, count);
+  outb(iobase + ATA_CB_SN, sector);
+  outb(iobase + ATA_CB_CL, cylinder & 0x00ff);
+  outb(iobase + ATA_CB_CH, cylinder >> 8);
+  outb(iobase + ATA_CB_DH, (slave ? ATA_CB_DH_DEV1 : ATA_CB_DH_DEV0) | (Bit8u)head);
+  outb(iobase + ATA_CB_CMD, command);
+
+  udelay(); /* spec says wait 400 ns , 1 us is close enough */
+  await_ide(NOT_BSY_DRQ, iobase, IDE_TIMEOUT);
+  status = inb(iobase + ATA_CB_STAT);
 
+  //BX_DEBUG_ATA("ata_cmd_data_in: device %d command %x count %x cylinder %x head %x sector %x lba %lx current %x\n",device, command, count, cylinder, head, sector, lba, current);
   if (status & ATA_CB_STAT_ERR) {
-    BX_DEBUG_ATA("ata_cmd_data_in : read error\n");
+    BX_DEBUG_ATA("ata_cmd_data_in : read error count = %x, sector = %x, cylinder = %x, head = %x, command = %x\n",
+			count, sector, cylinder, head, command, (translation == ATA_TRANSLATION_LBA? " LBA":" CHS"));
+	print_status(iobase);
     return 2;
     } else if ( !(status & ATA_CB_STAT_DRQ) ) {
     BX_DEBUG_ATA("ata_cmd_data_in : DRQ not set (status %02x)\n", (unsigned) status);
@@ -2593,7 +2687,7 @@
 ata_in_no_adjust:
         mov   es, ax      ;; segment in es
 
-        mov   dx, _ata_cmd_data_in.iobase1 + 2[bp] ;; ATA data read port
+        mov   dx, _ata_cmd_data_in.iobase + 2[bp] ;; ATA data read port
 
         mov  ah, _ata_cmd_data_in.mode + 2[bp] 
         cmp  ah, #ATA_MODE_PIO32
@@ -2617,7 +2711,8 @@
     current++;
     write_word(ebda_seg, &EbdaData->ata.trsfsectors,current);
     count--;
-    status = inb(iobase1 + ATA_CB_STAT);
+    await_ide(NOT_BSY,iobase,IDE_TIMEOUT);
+    status = inb(iobase + ATA_CB_STAT);
     if (count == 0) {
       if ( (status & (ATA_CB_STAT_BSY | ATA_CB_STAT_RDY | ATA_CB_STAT_DRQ | ATA_CB_STAT_ERR) ) 
           != ATA_CB_STAT_RDY ) {
@@ -2629,14 +2724,15 @@
     else {
       if ( (status & (ATA_CB_STAT_BSY | ATA_CB_STAT_RDY | ATA_CB_STAT_DRQ | ATA_CB_STAT_ERR) ) 
           != (ATA_CB_STAT_RDY | ATA_CB_STAT_DRQ) ) {
-        BX_DEBUG_ATA("ata_cmd_data_in : more sectors left (status %02x)\n", (unsigned) status);
+        BX_DEBUG_ATA("ata_cmd_data_in : more sectors left (status %02x)\n", status);
+        BX_DEBUG_ATA("ata_cmd_data_in : device %d command %x count %x cylinder %x head %x sector %x lba %lx segment %x offset %x current %x\n",device, command, count, cylinder, head, sector, lba, segment, offset, current);
         return 5;
       }
       continue;
     }
   }
   // Enable interrupts
-  outb(iobase2+ATA_CB_DC, ATA_CB_DC_HD15);
+  outb(iobase+ATA_CB_DC, ATA_CB_DC_HD15);
   return 0;
 }
 
@@ -2657,48 +2753,46 @@
 Bit32u lba;
 {
   Bit16u ebda_seg=read_word(0x0040,0x000E);
-  Bit16u iobase1, iobase2, blksize;
-  Bit8u  channel, slave;
+  Bit16u iobase, blksize;
+  Bit8u  channel, slave, translation;
   Bit8u  status, current, mode;
 
   channel = device / 2;
   slave   = device % 2;
 
-  iobase1 = read_word(ebda_seg, &EbdaData->ata.channels[channel].iobase1);
-  iobase2 = read_word(ebda_seg, &EbdaData->ata.channels[channel].iobase2);
+  iobase = read_word(ebda_seg, &EbdaData->ata.channels[channel].iobase);
   mode    = read_byte(ebda_seg, &EbdaData->ata.devices[device].mode);
+  translation = read_byte(ebda_seg,&EbdaData->ata.devices[device].translation);
   blksize = 0x200; // was = read_word(ebda_seg, &EbdaData->ata.devices[device].blksize);
   if (mode == ATA_MODE_PIO32) blksize>>=2;
   else blksize>>=1;
 
-  // sector will be 0 only on lba access. Convert to lba-chs
-  if (sector == 0) {
+  if(translation == ATA_TRANSLATION_LBA) //Convert to lba-chs
+  {
     sector = (Bit16u) (lba & 0x000000ffL);
-    lba >>= 8;
-    cylinder = (Bit16u) (lba & 0x0000ffffL);
-    lba >>= 16;
-    head = ((Bit16u) (lba & 0x0000000fL)) | 0x40;
-    }
+    cylinder = (Bit16u) ((lba>>8) & 0x0000ffffL);
+    head = ((Bit16u) ((lba>>24) & 0x0000000fL)) | ATA_CB_DH_LBA;
+  }
 
   // Reset count of transferred data
   write_word(ebda_seg, &EbdaData->ata.trsfsectors,0);
   write_dword(ebda_seg, &EbdaData->ata.trsfbytes,0L);
   current = 0;
 
-  status = inb(iobase1 + ATA_CB_STAT);
+  status = inb(iobase + ATA_CB_STAT);
   if (status & ATA_CB_STAT_BSY) return 1;
 
-  outb(iobase2 + ATA_CB_DC, ATA_CB_DC_HD15 | ATA_CB_DC_NIEN);
-  outb(iobase1 + ATA_CB_FR, 0x00);
-  outb(iobase1 + ATA_CB_SC, count);
-  outb(iobase1 + ATA_CB_SN, sector);
-  outb(iobase1 + ATA_CB_CL, cylinder & 0x00ff);
-  outb(iobase1 + ATA_CB_CH, cylinder >> 8);
-  outb(iobase1 + ATA_CB_DH, (slave ? ATA_CB_DH_DEV1 : ATA_CB_DH_DEV0) | (Bit8u) head );
-  outb(iobase1 + ATA_CB_CMD, command);
+  outb(iobase + ATA_CB_DC, ATA_CB_DC_HD15 | ATA_CB_DC_NIEN);
+  outb(iobase + ATA_CB_FR, 0x00);
+  outb(iobase + ATA_CB_SC, count);
+  outb(iobase + ATA_CB_SN, sector);
+  outb(iobase + ATA_CB_CL, cylinder & 0x00ff);
+  outb(iobase + ATA_CB_CH, cylinder >> 8);
+  outb(iobase + ATA_CB_DH, (slave ? ATA_CB_DH_DEV1 : ATA_CB_DH_DEV0) | (Bit8u) head );
+  outb(iobase + ATA_CB_CMD, command);
 
   while (1) {
-    status = inb(iobase1 + ATA_CB_STAT);
+    status = inb(iobase + ATA_CB_STAT);
     if ( !(status & ATA_CB_STAT_BSY) ) break;
     }
 
@@ -2736,7 +2830,7 @@
 ata_out_no_adjust:
         mov   es, ax      ;; segment in es
 
-        mov   dx, _ata_cmd_data_out.iobase1 + 2[bp] ;; ATA data write port
+        mov   dx, _ata_cmd_data_out.iobase + 2[bp] ;; ATA data write port
 
         mov  ah, _ata_cmd_data_out.mode + 2[bp] 
         cmp  ah, #ATA_MODE_PIO32
@@ -2762,7 +2856,7 @@
     current++;
     write_word(ebda_seg, &EbdaData->ata.trsfsectors,current);
     count--;
-    status = inb(iobase1 + ATA_CB_STAT);
+    status = inb(iobase + ATA_CB_STAT);
     if (count == 0) {
       if ( (status & (ATA_CB_STAT_BSY | ATA_CB_STAT_RDY | ATA_CB_STAT_DF | ATA_CB_STAT_DRQ | ATA_CB_STAT_ERR) ) 
           != ATA_CB_STAT_RDY ) {
@@ -2781,7 +2875,7 @@
     }
   }
   // Enable interrupts
-  outb(iobase2+ATA_CB_DC, ATA_CB_DC_HD15);
+  outb(iobase+ATA_CB_DC, ATA_CB_DC_HD15);
   return 0;
 }
 
@@ -2801,11 +2895,13 @@
 Bit32u length;
 {
   Bit16u ebda_seg=read_word(0x0040,0x000E);
-  Bit16u iobase1, iobase2;
+  Bit16u iobase;
   Bit16u lcount, lbefore, lafter, count;
+  Bit16u loops;
   Bit8u  channel, slave;
   Bit8u  status, mode, lmode;
   Bit32u total, transfer;
+  Bit8u  err, sc;
 
   channel = device / 2;
   slave = device % 2;
@@ -2815,6 +2911,10 @@
     BX_INFO("ata_cmd_packet: DATA_OUT not supported yet\n");
     return 1;
     }
+  if (inout == ATA_DATA_NO) {
+    BX_INFO("ata_cmd_packet: DATA_NO ???\n");
+    return 1;
+    }
 
   // The header length must be even
   if (header & 1) {
@@ -2822,8 +2922,7 @@
     return 1;
     }
 
-  iobase1 = read_word(ebda_seg, &EbdaData->ata.channels[channel].iobase1);
-  iobase2 = read_word(ebda_seg, &EbdaData->ata.channels[channel].iobase2);
+  iobase = read_word(ebda_seg, &EbdaData->ata.channels[channel].iobase);
   mode    = read_byte(ebda_seg, &EbdaData->ata.devices[device].mode);
   transfer= 0L;
 
@@ -2835,32 +2934,32 @@
   write_word(ebda_seg, &EbdaData->ata.trsfsectors,0);
   write_dword(ebda_seg, &EbdaData->ata.trsfbytes,0L);
 
-  status = inb(iobase1 + ATA_CB_STAT);
-  if (status & ATA_CB_STAT_BSY) return 2;
+  if (ata_device_selection(device,iobase,slave)!=0) return 2;
 
-  outb(iobase2 + ATA_CB_DC, ATA_CB_DC_HD15 | ATA_CB_DC_NIEN);
-  // outb(iobase1 + ATA_CB_FR, 0x00);
-  // outb(iobase1 + ATA_CB_SC, 0x00);
-  // outb(iobase1 + ATA_CB_SN, 0x00);
-  outb(iobase1 + ATA_CB_CL, 0xfff0 & 0x00ff);
-  outb(iobase1 + ATA_CB_CH, 0xfff0 >> 8);
-  outb(iobase1 + ATA_CB_DH, slave ? ATA_CB_DH_DEV1 : ATA_CB_DH_DEV0);
-  outb(iobase1 + ATA_CB_CMD, ATA_CMD_PACKET);
-
-  // Device should ok to receive command
-  while (1) {
-    status = inb(iobase1 + ATA_CB_STAT);
-    if ( !(status & ATA_CB_STAT_BSY) ) break;
-    }
+  outb(iobase + ATA_CB_DC, ATA_CB_DC_HD15 | ATA_CB_DC_NIEN);
+	/* Set up packet command */
+  outb(iobase + ATA_CB_FR, 0x00);
+  outb(iobase + ATA_CB_SC, 0x00);
+  //outb(iobase + ATA_CB_SN, 0x00);
+  outb(iobase + ATA_CB_CL, 0xfff0 & 0x00ff);
+  outb(iobase + ATA_CB_CH, 0xfff0 >> 8);
+  outb(iobase + ATA_CB_DH, slave ? ATA_CB_DH_DEV1 : ATA_CB_DH_DEV0);
+  outb(iobase + ATA_CB_CMD, ATA_CMD_PACKET);
+
+  udelay(); /* spec says wait 400 ns , 1 us is close enough */
+  await_ide(NOT_BSY_DRQ, iobase, IDE_TIMEOUT);
+  status = inb(iobase + ATA_CB_STAT);
 
   if (status & ATA_CB_STAT_ERR) {
     BX_DEBUG_ATA("ata_cmd_packet : error, status is %02x\n",status);
     return 3;
     } else if ( !(status & ATA_CB_STAT_DRQ) ) {
-    BX_DEBUG_ATA("ata_cmd_packet : DRQ not set (status %02x)\n", (unsigned) status);
+    BX_DEBUG_ATA("ata_cmd_packet : 1 DRQ not set (status %02x)\n", (unsigned) status);
     return 4;
     }
 
+  BX_DEBUG_ATA("Sending packet cmdseg = %x cmdoff = %x cmd[0] = %x\n",cmdseg,cmdoff,read_byte(cmdseg,cmdoff));
+
   // Normalize address
   cmdseg += (cmdoff / 16);
   cmdoff %= 16;
@@ -2877,7 +2976,7 @@
       mov  cx, _ata_cmd_packet.cmdlen + 2[bp] 
       mov  es, ax      ;; segment in es
 
-      mov  dx, _ata_cmd_packet.iobase1 + 2[bp] ;; ATA data write port
+      mov  dx, _ata_cmd_packet.iobase + 2[bp] ;; ATA data write port
 
       seg ES
       rep
@@ -2887,14 +2986,26 @@
 ASM_END
 
   if (inout == ATA_DATA_NO) {
-    status = inb(iobase1 + ATA_CB_STAT);
+    await_ide(NOT_BSY, iobase, IDE_TIMEOUT);
+    status = inb(iobase + ATA_CB_STAT);
+    sc = inb(iobase + ATA_CB_SC);
+    err = inb(iobase + ATA_CB_ERR);
+	BX_DEBUG_ATA("ata_cmd_packet: ATA_DATA_NO registers: SC %02x STATUS %02x ERR %02x\n",
+		sc,status,err);
     }
   else {
+	loops = 0;
   while (1) {
 
-      status = inb(iobase1 + ATA_CB_STAT);
+	if (loops == 0) //first time through
+		await_ide(NOT_BSY_DRQ, iobase, IDE_TIMEOUT);
+	loops++;
+
+      status = inb(iobase + ATA_CB_STAT);
+
+	mdelay(1);
+      BX_DEBUG_ATA("ata_cmd_packet: loop %d status=%02x\n",loops,status);
 
-      // Check if command completed
       if ( (status & (ATA_CB_STAT_BSY | ATA_CB_STAT_DRQ) ) ==0 ) break;
 
       if (status & ATA_CB_STAT_ERR) {
@@ -2902,19 +3013,12 @@
         return 3;
       }
 
-      // Device must be ready to send data
-      if ( (status & (ATA_CB_STAT_BSY | ATA_CB_STAT_RDY | ATA_CB_STAT_DRQ | ATA_CB_STAT_ERR) ) 
-            != (ATA_CB_STAT_RDY | ATA_CB_STAT_DRQ) ) {
-        BX_DEBUG_ATA("ata_cmd_packet : not ready (status %02x)\n", status);
-        return 4;
-        }
-
       // Normalize address
       bufseg += (bufoff / 16);
       bufoff %= 16;
     
       // Get the byte count
-      lcount =  ((Bit16u)(inb(iobase1 + ATA_CB_CH))<<8)+inb(iobase1 + ATA_CB_CL);
+      lcount =  ((Bit16u)(inb(iobase + ATA_CB_CH))<<8)+inb(iobase + ATA_CB_CL);
 
       // adjust to read what we want
       if(header>lcount) {
@@ -2971,7 +3075,7 @@
         push bp
         mov  bp, sp
 
-        mov  dx, _ata_cmd_packet.iobase1 + 2[bp] ;; ATA data read port
+        mov  dx, _ata_cmd_packet.iobase + 2[bp] ;; ATA data read port
 
         mov  cx, _ata_cmd_packet.lbefore + 2[bp] 
         jcxz ata_packet_no_before
@@ -3047,14 +3151,18 @@
     }
 
   // Final check, device must be ready
+      //status = inb(iobase + ATA_CB_ASTAT); // SPEC says read once and ignore
+  await_ide(NOT_BSY,iobase,IDE_TIMEOUT);
+      status = inb(iobase + ATA_CB_STAT);
   if ( (status & (ATA_CB_STAT_BSY | ATA_CB_STAT_RDY | ATA_CB_STAT_DF | ATA_CB_STAT_DRQ | ATA_CB_STAT_ERR) ) 
          != ATA_CB_STAT_RDY ) {
-    BX_DEBUG_ATA("ata_cmd_packet : not ready (status %02x)\n", (unsigned) status);
+    BX_DEBUG_ATA("ata_cmd_packet : not ready (status %02x)\n", status);
+	print_status(iobase);
     return 4;
     }
 
   // Enable interrupts
-  outb(iobase2+ATA_CB_DC, ATA_CB_DC_HD15);
+  outb(iobase+ATA_CB_DC, ATA_CB_DC_HD15);
   return 0;
 }
 
@@ -3067,51 +3175,107 @@
 // ---------------------------------------------------------------------------
 
   Bit16u 
-atapi_get_sense(device)
+atapi_get_sense(device, seg, asc, ascq)
   Bit16u device;
 {
   Bit8u  atacmd[12];
-  Bit8u  buffer[16];
+  Bit8u  buf[18];
   Bit8u i;
 
   memsetb(get_SS(),atacmd,0,12);
 
   // Request SENSE 
-  atacmd[0]=0x03;    
-  atacmd[4]=0x20;    
-  if (ata_cmd_packet(device, 12, get_SS(), atacmd, 0, 16L, ATA_DATA_IN, get_SS(), buffer) != 0)
-    return 0x0002;
+  atacmd[0]=ATA_CMD_REQUEST_SENSE;    
+  atacmd[4]=sizeof(buf);    
+  if (ata_cmd_packet(device, sizeof(atacmd), get_SS(), atacmd, 0, 18L, ATA_DATA_IN, get_SS(), buf) != 0)
+    return -1;
 
-  if ((buffer[0] & 0x7e) == 0x70) {
-    return (((Bit16u)buffer[2]&0x0f)*0x100)+buffer[12];
-    }
+  write_byte(seg,asc,buf[12]);
+  write_byte(seg,ascq,buf[13]);
 
   return 0;
 }
 
   Bit16u 
-atapi_is_ready(device)
+atapi_is_ready(device) //detect medium
   Bit16u device;
 {
-  Bit8u  atacmd[12];
-  Bit8u  buffer[];
+	Bit8u packet[12];
+	Bit8u buf[8];
+	Bit32u block_len; 
+	Bit32u sectors;
+	Bit32u timeout; //measured in ms
+	Bit32u time;
+	Bit8u asc, ascq;
+	Bit8u in_progress;
+	Bit16u ebda_seg = read_word(0x0040,0x000E);
+	if (read_byte(ebda_seg,&EbdaData->ata.devices[device].type) != ATA_TYPE_ATAPI) {
+		printf("not implemented for non-ATAPI device\n");
+		return -1;
+	}
 
-  memsetb(get_SS(),atacmd,0,12);
- 
-  // Test Unit Ready
-  if (ata_cmd_packet(device, 12, get_SS(), atacmd, 0, 0L, ATA_DATA_NO, get_SS(), buffer) != 0)
-    return 0x000f;
-
-  if (atapi_get_sense(device) !=0 ) {
-    memsetb(get_SS(),atacmd,0,12);
-
-    // try to send Test Unit Ready again
-    if (ata_cmd_packet(device, 12, get_SS(), atacmd, 0, 0L, ATA_DATA_NO, get_SS(), buffer) != 0)
-      return 0x000f;
+	BX_DEBUG_ATA("ata_detect_medium: begin\n");
+	print_status(read_word(ebda_seg,&EbdaData->ata.channels[device/2].iobase));
+	memsetb(get_SS(),packet, 0, sizeof packet);
+	packet[0] = 0x25; /* READ CAPACITY */
+
+	/* Retry READ CAPACITY for 5 seconds unless MEDIUM NOT PRESENT
+	 * is reported by the device. If the device reports "IN PROGRESS",
+	 * 30 seconds is added. */
+	timeout = 5000;
+	time = 0;
+	in_progress = 0;
+	while (time < timeout) {
+  		if (ata_cmd_packet(device, sizeof(packet), get_SS(), packet, 0, 8L, ATA_DATA_IN, get_SS(), buf) == 0)
+			goto ok;
+
+		if (atapi_get_sense(device, get_SS(), &asc, &ascq) == 0) {
+			if (asc == 0x3a) { /* MEDIUM NOT PRESENT */
+				BX_DEBUG_ATA("Device reports MEDIUM NOT PRESENT\n");
+				return -1;
+			}
+
+			if (asc == 0x04 && ascq == 0x01 && !in_progress) {
+					/* IN PROGRESS OF BECOMING READY */
+				printf("Waiting for device to detect medium... ");
+				/* Allow 30 seconds more */
+				timeout = 30000;
+				in_progress = 1;
+			}
+		}
 
-    return atapi_get_sense(device);
-    }
-  return 0;
+		mdelay(1000);
+		time += 100;
+	}
+	BX_DEBUG_ATA("read capacity failed\n");
+	return -1;
+ok:
+
+	block_len = (Bit32u) buf[4] << 24
+		| (Bit32u) buf[5] << 16
+		| (Bit32u) buf[6] << 8
+		| (Bit32u) buf[7] << 0;
+	BX_DEBUG_ATA("block_len=%u\n", block_len);
+
+	   if (block_len!= 2048 && block_len!= 512)
+	   {
+		printf("Unsupported sector size %u\n", block_len);
+		return -1;
+	   }
+	write_dword(ebda_seg,&EbdaData->ata.devices[device].blksize, block_len);
+
+	sectors = (Bit32u) buf[0] << 24
+		| (Bit32u) buf[1] << 16
+		| (Bit32u) buf[2] << 8
+		| (Bit32u) buf[3] << 0;
+
+	BX_DEBUG_ATA("sectors=%u\n", sectors);
+	if (block_len == 2048)
+		sectors <<= 2; /* # of sectors in 512-byte "soft" sector */
+	if (sectors != read_dword(ebda_seg,&EbdaData->ata.devices[device].sectors)) 
+		printf("%dMB medium detected\n", sectors>>(20-9));
+	write_dword(ebda_seg,&EbdaData->ata.devices[device].sectors, sectors);
+	return 0;
 }
 
   Bit16u 
@@ -3144,6 +3308,17 @@
 // Start of El-Torito boot functions
 // ---------------------------------------------------------------------------
 
+// I read somewhere that one inb = 1 us
+  void
+mdelay(msecs)
+Bit16u msecs;
+{
+  Bit16u i,j;
+	for (i=0;i<msecs;i++)
+		for (j=0;j<2048;j++)
+			udelay();
+}
+
   void
 cdemu_init()
 {
@@ -3188,6 +3363,9 @@
     if (atapi_is_cdrom(device)) break;
     }
   
+  if(error = atapi_is_ready(device) != 0)
+	bios_printf(BIOS_PRINTF_INFO | BIOS_PRINTF_SCREEN, "ata_is_ready returned %d\n",error);
+
   // if not found
   if(device >= BX_MAX_ATA_DEVICES) return 2;
 
@@ -3201,7 +3379,10 @@
   atacmd[4]=(0x11 & 0x0000ff00) >> 8;
   atacmd[5]=(0x11 & 0x000000ff);
   if((error = ata_cmd_packet(device, 12, get_SS(), atacmd, 0, 2048L, ATA_DATA_IN, get_SS(), buffer)) != 0)
-    return 3;
+  {
+	bios_printf(BIOS_PRINTF_INFO | BIOS_PRINTF_SCREEN, "ata_cmd_packet returned %d\n",error);
+     return 3;
+  }
 
   // Validity checks
   if(buffer[0]!=0)return 4;
@@ -4735,7 +4916,7 @@
 int13_harddisk(DS, ES, DI, SI, BP, ELDX, BX, DX, CX, AX, IP, CS, FLAGS)
   Bit16u DS, ES, DI, SI, BP, ELDX, BX, DX, CX, AX, IP, CS, FLAGS;
 {
-  Bit32u lba;
+  Bit32u lba=0xc0c0c0c0;
   Bit16u ebda_seg=read_word(0x0040,0x000E);
   Bit16u cylinder, head, sector;
   Bit16u segment, offset;
@@ -4743,6 +4924,7 @@
   Bit16u size, count;
   Bit8u  device, status;
 
+  if (GET_AH()>=0x40)
   BX_DEBUG_INT13_HD("int13_harddisk: AX=%04x BX=%04x CX=%04x DX=%04x ES=%04x\n", AX, BX, CX, DX, ES);
 
   write_byte(0x0040, 0x008e, 0);  // clear completion flag
@@ -4765,7 +4947,12 @@
   switch (GET_AH()) {
 
     case 0x00: /* disk controller reset */
-      ata_reset (device);
+      ata_reset(device);
+      goto int13_success;
+      break;
+
+    case 0x0d: /* alternate disk reset */
+      ata_device_reset(device);
       goto int13_success;
       break;
 
@@ -4809,19 +4996,15 @@
       // FIXME verify
       if ( GET_AH() == 0x04 ) goto int13_success;
 
-      nph   = read_word(ebda_seg, &EbdaData->ata.devices[device].pchs.heads);
-      npspt = read_word(ebda_seg, &EbdaData->ata.devices[device].pchs.spt);
-
-      // if needed, translate lchs to lba, and execute command
-      if ( (nph != nlh) || (npspt != nlspt)) {
+      if (read_byte(ebda_seg, &EbdaData->ata.devices[device].translation)==ATA_TRANSLATION_LBA)
         lba = ((((Bit32u)cylinder * (Bit32u)nlh) + (Bit32u)head) * (Bit32u)nlspt) + (Bit32u)sector - 1;
-        sector = 0; // this forces the command to be lba
-        }
+
+      //BX_INFO("int13_harddisk: function %02x, cyl %x, head %x, sector %x, LCHS:%x/%x/%x lba %lx\n",GET_AH(),cylinder,head,sector,nlc,nlh,nlspt,lba);
 
       if ( GET_AH() == 0x02 )
-        status=ata_cmd_data_in(device, ATA_CMD_READ_SECTORS, count, cylinder, head, sector, lba, segment, offset);
+        status=ata_cmd_data_in(device, ATA_CMD_READ_SECTORS, count, cylinder, head, sector, (Bit32u)lba, segment, offset);
       else
-        status=ata_cmd_data_out(device, ATA_CMD_WRITE_SECTORS, count, cylinder, head, sector, lba, segment, offset);
+        status=ata_cmd_data_out(device, ATA_CMD_WRITE_SECTORS, count, cylinder, head, sector,(Bit32u)lba, segment, offset);
 
       // Set nb of sector transferred
       SET_AL(read_word(ebda_seg, &EbdaData->ata.trsfsectors));
@@ -4849,14 +5032,18 @@
       nlspt = read_word(ebda_seg, &EbdaData->ata.devices[device].lchs.spt);
       count = read_byte(ebda_seg, &EbdaData->ata.hdcount);
 
+       //BX_INFO("int13_harddisk: function %02x, nlc %x, nlh %x, nlspt %x, count %x\n", GET_AH(),nlc,nlh,nlspt,count);
       nlc = nlc - 2; /* 0 based , last sector not used */
       SET_AL(0);
       SET_CH(nlc & 0xff);
       SET_CL(((nlc >> 2) & 0xc0) | (nlspt & 0x3f));
       SET_DH(nlh - 1);
       SET_DL(count); /* FIXME returns 0, 1, or n hard drives */
+      //SET_DL(1); /* FIXME returns 0, 1, or n hard drives */
 
-      // FIXME should set ES & DI
+      // FIXME should set ES & DI -- according to ctyme.com/intr/rb-0621.htm
+      ES = 0;
+      DI = 0;
       
       goto int13_success;
       break;
@@ -4865,7 +5052,7 @@
       // should look at 40:8E also???
       
       // Read the status from controller
-      status = inb(read_word(ebda_seg, &EbdaData->ata.channels[device/2].iobase1) + ATA_CB_STAT);
+      status = inb(read_word(ebda_seg, &EbdaData->ata.channels[device/2].iobase) + ATA_CB_STAT);
       if ( (status & ( ATA_CB_STAT_BSY | ATA_CB_STAT_RDY )) == ATA_CB_STAT_RDY ) {
         goto int13_success;
         }
@@ -4892,8 +5079,9 @@
       break;
 
     case 0x41: // IBM/MS installation check
-      BX=0xaa55;     // install check
-      SET_AH(0x30);  // EDD 3.0
+	//Phoenix userman.pdf says BX should be 0x55aa
+      BX=0x55aa;     // install check
+      SET_AH(0x20);  // EDD 2.0
       CX=0x0007;     // ext disk access and edd, removable supported
       goto int13_success_noah;
       break;
@@ -4927,9 +5115,9 @@
       
       // Execute the command
       if ( GET_AH() == 0x42 )
-        status=ata_cmd_data_in(device, ATA_CMD_READ_SECTORS, count, 0, 0, 0, lba, segment, offset);
+        status=ata_cmd_data_in(device, ATA_CMD_READ_SECTORS, count, 0, 0, 0, (Bit32u)lba, segment, offset);
       else
-        status=ata_cmd_data_out(device, ATA_CMD_WRITE_SECTORS, count, 0, 0, 0, lba, segment, offset);
+        status=ata_cmd_data_out(device, ATA_CMD_WRITE_SECTORS, count, 0, 0, 0, (Bit32u)lba, segment, offset);
 
       count=read_word(ebda_seg, &EbdaData->ata.trsfsectors);
       write_word(DS, SI+(Bit16u)&Int13Ext->count, count);
@@ -4983,7 +5171,7 @@
       // EDD 2.x
       if(size >= 0x1e) {
         Bit8u  channel, dev, irq, mode, checksum, i, translation;
-        Bit16u iobase1, iobase2, options;
+        Bit16u iobase, options;
 
         write_word(DS, SI+(Bit16u)&Int13DPT->size, 0x1e);
 
@@ -4992,21 +5180,21 @@
 
         // Fill in dpte
         channel = device / 2;
-        iobase1 = read_word(ebda_seg, &EbdaData->ata.channels[channel].iobase1);
-        iobase2 = read_word(ebda_seg, &EbdaData->ata.channels[channel].iobase2);
+        iobase = read_word(ebda_seg, &EbdaData->ata.channels[channel].iobase);
         irq = read_byte(ebda_seg, &EbdaData->ata.channels[channel].irq);
         mode = read_byte(ebda_seg, &EbdaData->ata.devices[device].mode);
         translation = read_byte(ebda_seg, &EbdaData->ata.devices[device].translation);
 
-        options  = (translation==ATA_TRANSLATION_NONE?0:1<<3); // chs translation
-        options |= (1<<4); // lba translation
+        //options  = (translation==ATA_TRANSLATION_NONE?0:1<<3); // chs translation
+        options = (1<<4); // lba translation
         options |= (mode==ATA_MODE_PIO32?1:0<<7);
         options |= (translation==ATA_TRANSLATION_LBA?1:0<<9); 
         options |= (translation==ATA_TRANSLATION_RECHS?3:0<<9); 
 
-        write_word(ebda_seg, &EbdaData->ata.dpte.iobase1, iobase1);
-        write_word(ebda_seg, &EbdaData->ata.dpte.iobase2, iobase2);
-        write_byte(ebda_seg, &EbdaData->ata.dpte.prefix, (0xe | (device % 2))<<4 );
+        write_word(ebda_seg, &EbdaData->ata.dpte.iobase1, iobase);
+        write_word(ebda_seg, &EbdaData->ata.dpte.iobase2, iobase + 0x204);
+		//Phoenix says should be 0xc0 or 0xd0
+        write_byte(ebda_seg, &EbdaData->ata.dpte.prefix, (0xc | (device % 2))<<4 );
         write_byte(ebda_seg, &EbdaData->ata.dpte.unused, 0xcb );
         write_byte(ebda_seg, &EbdaData->ata.dpte.irq, irq );
         write_byte(ebda_seg, &EbdaData->ata.dpte.blkcount, 1 );
@@ -5025,11 +5213,11 @@
       // EDD 3.x
       if(size >= 0x42) {
         Bit8u channel, iface, checksum, i;
-        Bit16u iobase1;
+        Bit16u iobase;
 
         channel = device / 2;
         iface = read_byte(ebda_seg, &EbdaData->ata.channels[channel].iface);
-        iobase1 = read_word(ebda_seg, &EbdaData->ata.channels[channel].iobase1);
+        iobase = read_word(ebda_seg, &EbdaData->ata.channels[channel].iobase);
 
         write_word(DS, SI+(Bit16u)&Int13DPT->size, 0x42);
         write_word(DS, SI+(Bit16u)&Int13DPT->key, 0xbedd);
@@ -5052,7 +5240,7 @@
         write_byte(DS, SI+(Bit16u)&Int13DPT->iface_type[3], 0);
 
         if (iface==ATA_IFACE_ISA) {
-          write_word(DS, SI+(Bit16u)&Int13DPT->iface_path[0], iobase1);
+          write_word(DS, SI+(Bit16u)&Int13DPT->iface_path[0], iobase);
           write_word(DS, SI+(Bit16u)&Int13DPT->iface_path[2], 0);
           write_dword(DS, SI+(Bit16u)&Int13DPT->iface_path[4], 0L);
           }
@@ -5089,7 +5277,6 @@
 
     case 0x09: /* initialize drive parameters */
     case 0x0c: /* seek to specified cylinder */
-    case 0x0d: /* alternate disk reset */
     case 0x11: /* recalibrate */
     case 0x14: /* controller internal diagnostic */
       BX_INFO("int13h_harddisk function %02xh unimplemented, returns success\n", GET_AH());
@@ -5332,7 +5519,7 @@
       // EDD 2.x
       if(size >= 0x1e) {
         Bit8u  channel, dev, irq, mode, checksum, i;
-        Bit16u iobase1, iobase2, options;
+        Bit16u iobase, options;
 
         write_word(DS, SI+(Bit16u)&Int13DPT->size, 0x1e);
 
@@ -5341,8 +5528,7 @@
 
         // Fill in dpte
         channel = device / 2;
-        iobase1 = read_word(ebda_seg, &EbdaData->ata.channels[channel].iobase1);
-        iobase2 = read_word(ebda_seg, &EbdaData->ata.channels[channel].iobase2);
+        iobase = read_word(ebda_seg, &EbdaData->ata.channels[channel].iobase);
         irq = read_byte(ebda_seg, &EbdaData->ata.channels[channel].irq);
         mode = read_byte(ebda_seg, &EbdaData->ata.devices[device].mode);
 
@@ -5352,9 +5538,10 @@
         options |= (1<<6); // atapi device
         options |= (mode==ATA_MODE_PIO32?1:0<<7);
 
-        write_word(ebda_seg, &EbdaData->ata.dpte.iobase1, iobase1);
-        write_word(ebda_seg, &EbdaData->ata.dpte.iobase2, iobase2);
-        write_byte(ebda_seg, &EbdaData->ata.dpte.prefix, (0xe | (device % 2))<<4 );
+        write_word(ebda_seg, &EbdaData->ata.dpte.iobase1, iobase);
+        write_word(ebda_seg, &EbdaData->ata.dpte.iobase2, iobase + 0x204);
+		//Phoenix says should be 0xc0 or 0xd0
+        write_byte(ebda_seg, &EbdaData->ata.dpte.prefix, (0xc | (device % 2))<<4 );
         write_byte(ebda_seg, &EbdaData->ata.dpte.unused, 0xcb );
         write_byte(ebda_seg, &EbdaData->ata.dpte.irq, irq );
         write_byte(ebda_seg, &EbdaData->ata.dpte.blkcount, 1 );
@@ -5373,11 +5560,11 @@
       // EDD 3.x
       if(size >= 0x42) {
         Bit8u channel, iface, checksum, i;
-        Bit16u iobase1;
+        Bit16u iobase;
 
         channel = device / 2;
         iface = read_byte(ebda_seg, &EbdaData->ata.channels[channel].iface);
-        iobase1 = read_word(ebda_seg, &EbdaData->ata.channels[channel].iobase1);
+        iobase = read_word(ebda_seg, &EbdaData->ata.channels[channel].iobase);
 
         write_word(DS, SI+(Bit16u)&Int13DPT->size, 0x42);
         write_word(DS, SI+(Bit16u)&Int13DPT->key, 0xbedd);
@@ -5400,7 +5587,7 @@
         write_byte(DS, SI+(Bit16u)&Int13DPT->iface_type[3], 0);
 
         if (iface==ATA_IFACE_ISA) {
-          write_word(DS, SI+(Bit16u)&Int13DPT->iface_path[0], iobase1);
+          write_word(DS, SI+(Bit16u)&Int13DPT->iface_path[0], iobase);
           write_word(DS, SI+(Bit16u)&Int13DPT->iface_path[2], 0);
           write_dword(DS, SI+(Bit16u)&Int13DPT->iface_path[4], 0L);
           }
@@ -6378,6 +6565,7 @@
 
 #endif //else BX_USE_ATADRV
 
+#if BX_SUPPORT_FLOPPY
 
 //////////////////////
 // FLOPPY functions //
@@ -6651,7 +6839,6 @@
     return(1);
 }
 
-#if BX_SUPPORT_FLOPPY
   void
 int13_diskette_function(DS, ES, DI, SI, BP, ELDX, BX, DX, CX, AX, IP, CS, FLAGS)
   Bit16u DS, ES, DI, SI, BP, ELDX, BX, DX, CX, AX, IP, CS, FLAGS;
@@ -9798,6 +9985,7 @@
   call _ata_init
   call _ata_detect
   ;;
+  ;;
 #else // BX_USE_ATADRV
 
   ;;
@@ -10546,6 +10734,6 @@
 };
 
 ASM_START
-.org 0xcc00
+.org 0xc000
 // bcc-generated data will be placed here
 ASM_END
Only in bios/: .svn
